#include <math.h>
#include <iostream>
#include <conio.h>
#include <vector>
#include <string>
#include "svg.h"
using namespace std;

void
svg_begin(double width, double height)
{
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void
svg_end()
{
    cout << "</svg>\n";
}
void
svg_text(double left, double baseline, string text)
{
    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}

void
svg_rect(double x, double y, double width, double height, string stroke, string fill)
{
    cout << "<rect x='"<<x<<"' y='"<<y<<"' width='"<<width<<"' height='"<<height<<"' stroke='"<<stroke<<"' fill='"<<fill<<"' />";

}


void
show_histogram_svg(const vector<size_t>& bins, size_t number_count)
{
    setlocale(LC_ALL, "Russian");
    int noi=0;
    auto IMAGE_WIDTH = 0;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    const auto MAX_WIDTH = IMAGE_WIDTH-TEXT_WIDTH;
//
    cerr<<"   ";
    //cerr<<endl;
    cerr<<",      70   800,  ";
   // cerr<<endl;
    cerr<<"   ,     .     "<<(( number_count*BLOCK_WIDTH)/3)<<" ";
    //cerr<<endl;
    //cin>>IMAGE_WIDTH;
    while (noi == 0)
    {
        cerr<<" in cicle";
        //cerr<<endl;
        cin>> IMAGE_WIDTH;
        if ((IMAGE_WIDTH<800)&&(IMAGE_WIDTH>70)&&(IMAGE_WIDTH>(number_count*BLOCK_WIDTH)/3))
        {
            noi=noi+1;
        }

        if (IMAGE_WIDTH>800)
        {
            cerr<<"     800.  ";
           // cerr<<endl;
        }
        if (IMAGE_WIDTH<70)
        {
            cerr<<"     70. ";
            //cerr<<endl;
        }
        if (IMAGE_WIDTH<(number_count*BLOCK_WIDTH)/3)
        {
            cerr<<"     " << (number_count*BLOCK_WIDTH)/3<<"  ";
           // cerr<<endl;
        }

    }



//string k;
//string m;
    svg_begin(IMAGE_WIDTH,IMAGE_HEIGHT);

    double top = 0; //
    double max_count = bins[0];
    for (size_t i = 0; i < bins.size(); i++)
    {
        if (bins[i] > max_count)
            max_count = bins[i];
    }
    for (size_t bin : bins)
    {
        const double bin_width = (IMAGE_WIDTH - TEXT_WIDTH)*(bin/max_count);
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, to_string(bin));
        /*/
        cout<<"  1   #RRGGBB";
        cin>> k;
        cout<<endl;
        cout<<"  2   #RRGGBB";
        cin >> m;
        /*/
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT,"#00CCFF" /*/k/*/,"#0000FF" /*/m/*/);
        top += BIN_HEIGHT;
    }

    svg_end();
}
